﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WPFResourcesStyles
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Person> people = new ObservableCollection<Person>();
        public MainWindow()
        {
            InitializeComponent();
            DataView.ItemsSource = people;
        }

        private void OpenMenuItem_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            if(dialog.ShowDialog()==true)
            {
                LoadData(dialog.FileName);
            }
        }

        private void LoadData(string filename)
        {
            using (StreamReader reader = new StreamReader(filename))
            {
                string line;
                while((line=reader.ReadLine())!=null)
                {
                    people.Add(Person.Parse(line));
                }
            }
        }

        private void SaveMenuItem_Click(object sender, RoutedEventArgs e)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            if (dialog.ShowDialog() == true)
            {
                SaveData(dialog.FileName);
            }
        }

        private void SaveData(string filename)
        {
            using (StreamWriter writer = new StreamWriter(filename))
            {
                foreach (Person person in people)
                {
                    writer.WriteLine(person);
                }
            }
        }

        private void NewMenuItem_Click(object sender, RoutedEventArgs e)
        {
            people.Clear();
        }

        private void ExitMenuItem_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Shutdown();
        }

        private void AddMenuItem_Click(object sender, RoutedEventArgs e)
        {
            AddDialog dialog = new AddDialog();
            if (dialog.ShowDialog() == true)
            {
                people.Add(dialog.Person);
            }

        }

        private void RemoveMenuItem_Click(object sender, RoutedEventArgs e)
        {
            if(DataView.SelectedIndex>=0)
            {
                people.RemoveAt(DataView.SelectedIndex);
            }
        }
    }
}
